package info.lotosummary.software;
import java.util.Calendar;

public class Consecutive extends Characterizable {
    boolean readyToRebuild;
    GapID d;
    int anchorLength, featuresLength, lengthAfterName, lengthBeforeName, partsLength, session;
    String after, anchor, before, date, day, gap_id, name, parts, res_no, res_time;

    private String padding(String s) {
        StringBuffer h = new StringBuffer();
        h.append(s);
        h.append(WIDE_SPACE);
        s = h.toString();
        return s.substring(0, SPACE_WIDTH);
    }

    private int sequenceOfNumbers(String line) {
        int q = 0;
        int size = line.length();
        String c;
        for(int i = 0; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                continue;
            } else {
                q = i;
                break;
            }

        }

        return q;
    }

    private int stringToInteger(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e5) {
            plus("NumberFormatException e5");
            return NOT_CONVERTED;
        }

    }

    private String fixedWidth(int n, char c, int width) {
        char[] padding = new char[width];
        for(int i = 0; i < width; ++i) {
            padding[i] = c;
        }

        String p = new String(padding);

        StringBuffer os = new StringBuffer();
        os.append(n);
        String tail = os.toString();
        int number_length = tail.length();

        int q = width - number_length;
        String head = p.substring(0, q);
        String fixed_width_number = head + tail;
        return fixed_width_number;
    }

    public Consecutive(String s, String a, String b, String f) {
        anchor = a;
        anchorLength = anchor.length();
        date = EMPTY;
        day = EMPTY;
        gap_id = EMPTY;
        line = s;
        name = EMPTY;
        parts = anchor + TWO_SPACES;
        partsLength = parts.length();
        readyToRebuild = false;
        res_no = EMPTY;
        res_time = EMPTY;
        session = 0;

        String features = "/05/ 08:";
        before = b;
        lengthBeforeName = before.length();
        after = f;
        lengthAfterName = after.length();
        features = before + after + features; // "FF/05/ 08:"
        featuresLength = features.length();

        d = new GapID();
        error = EMPTY;
    }

    public int isDateLine(int f) {
        lineLength = line.length();
        if(lineLength <= f) {
            return NON_DATE_LINE;
        }

        line = line.substring(f);
        lineLength = line.length();
        if(lineLength < featuresLength) {
            return NON_DATE_LINE;
        }

        String copied = line.substring(MARK_INDEX, MARK_INDEX + 1 );
        if( copied.equals(MARK) ) {
            return DATE_LINE;
        }

        int p;
        int[] r = new int[ARRAY_SIZE];

        copied = line.substring(0, 1);
        p = N_1TO9.indexOf(copied);
        if(p >= 0) { // res-number
            ;
        } else {
            return NON_DATE_LINE;
        }

        int g = sequenceOfNumbers(line);
        if(g <= 4) { // 6, 153, 172, 372, 879, 985, 986, 1703, for example
            p = line.indexOf(before);
            if(p >= 0) { // before the name
                int b = p;
                p += lengthBeforeName;
                tail = line.substring(p);
                p = tail.indexOf(after);
// 879 OF񁗖ς[sage] eF2011/05/03() 08:09:07.62 ID:OIJ+W51w
//    g    b                                    a   m s     w                           
                if(p >= 0) { // after the name
                    name = tail.substring(0, p);
                    int a = b + lengthBeforeName + p;
                    p += lengthAfterName;
                    tail = tail.substring(p);
                    r[0] = tail.indexOf("/01/");
                    r[1] = tail.indexOf("/02/");
                    r[2] = tail.indexOf("/03/");
                    r[3] = tail.indexOf("/04/");
                    r[4] = tail.indexOf("/05/");
                    r[5] = tail.indexOf("/06/");
                    r[6] = tail.indexOf("/07/");
                    r[7] = tail.indexOf("/08/");
                    r[8] = tail.indexOf("/09/");
                    r[9] = tail.indexOf("/10/");
                    r[10] = tail.indexOf("/11/");
                    r[11] = tail.indexOf("/12/");
                    int c = 0;
                    p = tail.length();
                    for(int i = 0; i < TWELVE_MONTHS; ++i) {
                        if(r[i] >= 0) {
                            p = r[i];
                            ++c;
                        }

                    }

                    if(c == 1) { // A slash-month-slash String can be found.
                        int slash_month_slash = a + lengthAfterName + p;
                        p += SLASH_MONTH_SLASH_SIZE;
                        tail = tail.substring(p);
                        r[0] = tail.indexOf(" 00:");
                        r[1] = tail.indexOf(" 01:");
                        r[2] = tail.indexOf(" 02:");
                        r[3] = tail.indexOf(" 03:");
                        r[4] = tail.indexOf(" 04:");
                        r[5] = tail.indexOf(" 05:");
                        r[6] = tail.indexOf(" 06:");
                        r[7] = tail.indexOf(" 07:");
                        r[8] = tail.indexOf(" 08:");
                        r[9] = tail.indexOf(" 09:");
                        r[10] = tail.indexOf(" 10:");
                        r[11] = tail.indexOf(" 11:");
                        r[12] = tail.indexOf(" 12:");
                        r[13] = tail.indexOf(" 13:");
                        r[14] = tail.indexOf(" 14:");
                        r[15] = tail.indexOf(" 15:");
                        r[16] = tail.indexOf(" 16:");
                        r[17] = tail.indexOf(" 17:");
                        r[18] = tail.indexOf(" 18:");
                        r[19] = tail.indexOf(" 19:");
                        r[20] = tail.indexOf(" 20:");
                        r[21] = tail.indexOf(" 21:");
                        r[22] = tail.indexOf(" 22:");
                        r[23] = tail.indexOf(" 23:"); // 2ch
                        r[24] = tail.indexOf(")00:"); // Open2ch
                        r[25] = tail.indexOf(")01:");
                        r[26] = tail.indexOf(")02:");
                        r[27] = tail.indexOf(")03:");
                        r[28] = tail.indexOf(")04:");
                        r[29] = tail.indexOf(")05:");
                        r[30] = tail.indexOf(")06:");
                        r[31] = tail.indexOf(")07:");
                        r[32] = tail.indexOf(")08:");
                        r[33] = tail.indexOf(")09:");
                        r[34] = tail.indexOf(")10:");
                        r[35] = tail.indexOf(")11:");
                        r[36] = tail.indexOf(")12:");
                        r[37] = tail.indexOf(")13:");
                        r[38] = tail.indexOf(")14:");
                        r[39] = tail.indexOf(")15:");
                        r[40] = tail.indexOf(")16:");
                        r[41] = tail.indexOf(")17:");
                        r[42] = tail.indexOf(")18:");
                        r[43] = tail.indexOf(")19:");
                        r[44] = tail.indexOf(")20:");
                        r[45] = tail.indexOf(")21:");
                        r[46] = tail.indexOf(")22:");
                        r[47] = tail.indexOf(")23:");
                        c = 0;
                        p = tail.length();
                        for(int i = 0; i < ARRAY_SIZE; ++i) {
                            if(r[i] >= 0) {
                                p = r[i];
                                ++c;
                            }

                        }

                        if(c == 1) {
                            int beginning_of_time = p + 1;

// ID
                            p = line.indexOf(ID_COLON);
                            if(p >= 0) {
                                gap_id = line.substring(p);
                                int idLength = gap_id.length();
                                if( idLength < SPACE_WIDTH ) {
                                    gap_id = padding(gap_id);
                                }

                            } else {
                                gap_id = WIDE_SPACE;
                            }

// res time
                            tail = tail.substring(beginning_of_time);
                            p = tail.indexOf(GAP);
                            if(p >= 0) {
                                res_time = tail.substring(0, p); // 07:13:18
                            } else {
                                res_time = tail;
                            }

                            int timeLength = res_time.length();
                            if( timeLength < SPACE_WIDTH ) {
                                res_time = padding(res_time);
                            }

// date
                            int m = slash_month_slash - 2;
                            int w = m + DATE_SIZE; 
                            String HEAD = "20";
                            tail = line.substring(m, m + DATE_SIZE ); // 11/06/06
                            date = HEAD + tail;

                            copied = line.substring(w, w + 1 );
                            if( copied.equals("(") ) {
                                w += 1;
                                copied = line.substring(w, w + KANJI_SIZE );
                                p = YOBI.indexOf(copied);
                                StringBuffer h = new StringBuffer();
                                h.append("(");
                                h.append(weekdays[p]);
                                h.append(")");
                                day = h.toString();
                            }

// res number
                            res_no = line.substring(0, g);

// name
                            p = name.indexOf(TOKOBI);
                            if(p >= 0) {
                                head = name.substring(0, p);
                                p += TOKOBI_SIZE;
                                tail = name.substring(p);
                                name = head + tail;
                            }

                            readyToRebuild = true;
                            return m;
                        }

                    }

                }

            }

        }
    
        return NON_DATE_LINE;
    }

    public String anchorLine() {
        int p;

        lineLength = line.length();
        if(lineLength < partsLength) {
            return NON_ANCHOR_LINE;
        }

        int h = line.indexOf(anchor);
        if(h == 0) { // anchor
            int n = h + anchorLength;
            tail = line.substring(n);
// >>965@02 16 18 28 32 35 QP@񁗖ς[] ID:KLgxbcxo
// h n  s q                   a                                     
            String copied = tail.substring(0, 1);
            p = N_1TO9.indexOf(copied);
            if(p >= 0) { // res-number
                p = tail.indexOf(SPACE);
                if(p >= 0) { // SPACE-1
                    int s = n + p;
                    int q = s + SPACE_SIZE;
                    p += SPACE_SIZE;
                    tail = tail.substring(p);

                    p = tail.indexOf(SPACE);
                    if(p >= 0) { // SPACE-2
                        int count = p;
                        p += SPACE_SIZE;
                        tail = tail.substring(p);

                        p = tail.indexOf(SPACE);
                        if(p >= 0) { // SPACE-3
                            return NON_ANCHOR_LINE;
                        } else {
                            return line.substring(q, q + count );
                        }

                    }

                }

            }

        }

        return NON_ANCHOR_LINE;
    }

    public String lotoLine() {
        return EMPTY;
    }

    public String rebuild() {
        if(readyToRebuild) {
            StringBuffer h = new StringBuffer();
            res_time = resTime();

            int res_number = stringToInteger(res_no);
            res_number += 1;

            h.append(res_number);
            h.append(GAP);
            h.append(before);
            h.append(name);
            h.append(after);
            h.append(date);
            h.append(day);
            h.append(GAP);
            h.append(res_time);
            h.append(gap_id);
            line = h.toString();

            int g = line.indexOf(GAP);
            res_no = line.substring(0, g);

            session += 1;
            if( session%REPEATED_POST == 0 ) {
                gap_id = d.gapID();
                if( gap_id.length() == 0 ) {
                    if(session == REPEATED_POST) {
                        plus( d.inquiry() );
                    }

                }

            }

        }

        return line;
    }

    private String resTime() {
        Calendar calendar = Calendar.getInstance();
        String sequence = date;

/*
01234567890
2011/05/03 
*/
        String YYYY = sequence.substring(0, 4);
        int years = stringToInteger(YYYY);

        String MM = sequence.substring(5, 7);
        int months = stringToInteger(MM);

        String DD = sequence.substring(8, 10);
        int days = stringToInteger(DD);

/*
012345678901
08:09:07.62 
*/
        int q = res_time.indexOf(GAP);
        if(q >= 0) {
            sequence = res_time.substring(0, q);
        } else {
            sequence = res_time;
        }

        int sequenceLength = sequence.length();
        if(sequenceLength < HOURS_MINUTES_SIZE) {
            String NOON = "00:00:00";
            sequence = NOON;
        } else if(sequenceLength < HOURS_MINUTES_SECONDS_SIZE) {
            String CLEAR = ":00";
            sequence += CLEAR;
        }

        String hh = sequence.substring(0, 2);
        int hours = stringToInteger(hh);

        String mm = sequence.substring(3, 5);
        int minutes = stringToInteger(mm);

        String ss = sequence.substring(6, 8);
        int seconds = stringToInteger(ss);

        calendar.set(years, months, days, hours, minutes, seconds);
        calendar.add(Calendar.SECOND, BREAK_TIME);

        hours = calendar.get(Calendar.HOUR_OF_DAY);
        minutes = calendar.get(Calendar.MINUTE);
        seconds = calendar.get(Calendar.SECOND);
        sequence = fixedWidth(hours, '0', 2) + ":" + fixedWidth(minutes, '0', 2) + ":" + fixedWidth(seconds, '0', 2);
        return sequence;
    }

}
